
void _efl_ui_format_format_func_set(Eo *obj, Efl_Ui_Format_Data *pd, void *func_data, Efl_Ui_Format_Func func, Eina_Free_Cb func_free_cb);

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_format_func_set, EFL_FUNC_CALL(func_data, func, func_free_cb), void *func_data, Efl_Ui_Format_Func func, Eina_Free_Cb func_free_cb);

Efl_Ui_Format_Func _efl_ui_format_format_func_get(const Eo *obj, Efl_Ui_Format_Data *pd);

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_ui_format_func_get, Efl_Ui_Format_Func, 0);

void _efl_ui_format_format_values_set(Eo *obj, Efl_Ui_Format_Data *pd, Eina_Accessor *values);

static void
_efl_ui_format_values_set_ownership_fallback(Eina_Accessor *values)
{
   eina_accessor_free(values);
}

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV_FALLBACK(efl_ui_format_values_set, _efl_ui_format_values_set_ownership_fallback(values);, EFL_FUNC_CALL(values), Eina_Accessor *values);

Eina_Accessor *_efl_ui_format_format_values_get(const Eo *obj, Efl_Ui_Format_Data *pd);

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_ui_format_values_get, Eina_Accessor *, NULL);

void _efl_ui_format_format_string_set(Eo *obj, Efl_Ui_Format_Data *pd, const char *string, Efl_Ui_Format_String_Type type);

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_format_string_set, EFL_FUNC_CALL(string, type), const char *string, Efl_Ui_Format_String_Type type);

void _efl_ui_format_format_string_get(const Eo *obj, Efl_Ui_Format_Data *pd, const char **string, Efl_Ui_Format_String_Type *type);

static void __eolian_efl_ui_format_format_string_get(const Eo *obj, Efl_Ui_Format_Data *pd, const char **string, Efl_Ui_Format_String_Type *type)
{
   if (type) *type = 0; /* Efl.Ui.Format_String_Type.simple */
   _efl_ui_format_format_string_get(obj, pd, string, type);
}

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV_CONST(efl_ui_format_string_get, EFL_FUNC_CALL(string, type), const char **string, Efl_Ui_Format_String_Type *type);

void _efl_ui_format_formatted_value_get(Eo *obj, Efl_Ui_Format_Data *pd, Eina_Strbuf *str, const Eina_Value value);

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_format_formatted_value_get, EFL_FUNC_CALL(str, value), Eina_Strbuf *str, const Eina_Value value);

int _efl_ui_format_decimal_places_get(Eo *obj, Efl_Ui_Format_Data *pd);

EAPI EAPI_WEAK EFL_FUNC_BODY(efl_ui_format_decimal_places_get, int, 0);
EAPI EAPI_WEAK EFL_VOID_FUNC_BODY(efl_ui_format_apply_formatted_value);

void _efl_ui_format_efl_object_destructor(Eo *obj, Efl_Ui_Format_Data *pd);


static Eina_Bool
_efl_ui_format_class_initializer(Efl_Class *klass)
{
   const Efl_Object_Ops *opsp = NULL;

   const Efl_Object_Property_Reflection_Ops *ropsp = NULL;

#ifndef EFL_UI_FORMAT_EXTRA_OPS
#define EFL_UI_FORMAT_EXTRA_OPS
#endif

   EFL_OPS_DEFINE(ops,
      EFL_OBJECT_OP_FUNC(efl_ui_format_func_set, _efl_ui_format_format_func_set),
      EFL_OBJECT_OP_FUNC(efl_ui_format_func_get, _efl_ui_format_format_func_get),
      EFL_OBJECT_OP_FUNC(efl_ui_format_values_set, _efl_ui_format_format_values_set),
      EFL_OBJECT_OP_FUNC(efl_ui_format_values_get, _efl_ui_format_format_values_get),
      EFL_OBJECT_OP_FUNC(efl_ui_format_string_set, _efl_ui_format_format_string_set),
      EFL_OBJECT_OP_FUNC(efl_ui_format_string_get, __eolian_efl_ui_format_format_string_get),
      EFL_OBJECT_OP_FUNC(efl_ui_format_formatted_value_get, _efl_ui_format_formatted_value_get),
      EFL_OBJECT_OP_FUNC(efl_ui_format_decimal_places_get, _efl_ui_format_decimal_places_get),
      EFL_OBJECT_OP_FUNC(efl_ui_format_apply_formatted_value, NULL),
      EFL_OBJECT_OP_FUNC(efl_destructor, _efl_ui_format_efl_object_destructor),
      EFL_UI_FORMAT_EXTRA_OPS
   );
   opsp = &ops;

   return efl_class_functions_set(klass, opsp, ropsp);
}

static const Efl_Class_Description _efl_ui_format_class_desc = {
   EO_VERSION,
   "Efl.Ui.Format",
   EFL_CLASS_TYPE_MIXIN,
   sizeof(Efl_Ui_Format_Data),
   _efl_ui_format_class_initializer,
   NULL,
   NULL
};

EFL_DEFINE_CLASS(efl_ui_format_mixin_get, &_efl_ui_format_class_desc, NULL, NULL);
